<?php
/*
Plugin Name: Franken CatVis SimpEx
Plugin URI: http://ipeat.com/?p=118
Description: Alter the visibility settings for categories, for WordPress 2.3. Based on an earlier Category Visibility by Rich Hamilton, Keith McDuffee, and Projekt Seven.
Author: iPeat / Paul Menard
Version: alpha
Author URI: http://ipeat.com
*/

/*

A mashup up Simple Exclude by Paul Menard  and the List feature of Category Visibility by iPeat

* i have been trying to figure out what changed from 2.5 to 2.5.1 that has caused my where clause on the home/ main page with little results.  In that time I have found the Simple exclude Plugin by Paul Menard, it accomplish most of the same goals with a very different method.
*  To fill the whole that it miss I have mashed in part of my plugin.  
*  In doing so have found about 3 additional bugs in both mine plugin and his mainly having to do with categories and archives.

So I post the Alpha Plugin To help you get by to install please follow these steps:
1. Reactivate Category Visibility if you have deactivated it.
2. Make sure all categories have been checked.
3. Deactivate Category Visibility.
4. Activate the Frankenstein Plugin.
5. List Category Visibilty can be found under Manage.
6. Simple Exclude can be found under Settings.

*/

$cat_visibility = $table_prefix . 'cat_visibility';

function cv_category_vis_menu () {

    add_submenu_page('edit.php', 'List Category Exclude', 'List Category Exclude', 'manage_categories', basename(__FILE__), 'category_visibility');

}

function category_visibility () {

    global $wpdb;
    global $cat_visibility;
	global $wp_roles;

?>
<?php if ($_POST["action"] == "editcatvis"): ?>
<div class="updated"><p><strong><?php _e('Changes Submitted.'); ?></strong></p></div>
<?php endif; ?>
<div class="wrap">
<?php if ( current_user_can('manage_categories') ) { ?>
    <h2><?php _e('Link Category Visibility') ?> </h2>
<?php } ?>
<form name="catvis" id="catvis" action="edit.php?page=<?php echo basename(__FILE__); ?>" method="post">
<table width="100%" cellpadding="3" cellspacing="3">
        <tr>
        <th scope="col"><?php _e('ID') ?></th>
        <th scope="col"><?php _e('Name') ?></th>
        <th scope="col"><?php _e('Visibility') ?></th>
        </tr>
<?php
if ($_POST["action"] == "editcatvis") {
    cv_edit_cat_vis();
}

cv_my_cat_rows();
?>
</table>
<p class="submit"><input type="hidden" name="action" value="editcatvis" /><input type="submit" name="submit" value="<?php _e('Submit Changes &raquo;') ?>" />
</p>
</form>

</div>
<?php
}

function cv_my_cat_rows($parent = 0, $level = 0, $categories = 0) {

    global $wpdb, $class;
    global $cat_visibility;

	// $pagenow is edit.php

	if (!$categories)
		$categories = $wpdb->get_results("SELECT * FROM $wpdb->terms LEFT JOIN $wpdb->term_taxonomy ON ($wpdb->terms.term_id = $wpdb->term_taxonomy.term_id) WHERE $wpdb->term_taxonomy.term_id <> 'post_tag' $ORDER BY name");

	if ($categories) {
		foreach ($categories as $category) {
			if ($category->category_parent == $parent) {
				$category->name = wp_specialchars($category->name);
				$pad = str_repeat('&#8212; ', $level);
				if ( current_user_can('manage_categories') ) {
					$catvis = $wpdb->get_results("SELECT * FROM $cat_visibility WHERE cat_ID=$category->term_id LIMIT 1");
					$catvis = $catvis[0];
					if ($catvis->list == 1 || $catvis == 0) $catvis_list = "checked"; else $catvis_list = "";
					$edit  = "<label for='" . $category->term_id . "_list'>Exclude:</label> <input name='" . $category->term_id . "_list' id='" . $category->term_id . "_list' class='edit' type='checkbox' $catvis_list />&nbsp;&nbsp;";
				} else
					$edit = '';
				$class = ('alternate' == $class) ? '' : 'alternate';
				echo "<tr class='$class'><th scope='row'>$category->term_id</th><td>$pad $category->name</td>
	 					<td style='text-align: center'>$edit</td>
						</tr>";
				cv_my_cat_rows($category->term_id, $level + 1, $categories);
			}
		}
	} else {
		return false;
	}
}

function cv_edit_cat_vis () {

    global $wpdb;
    global $cat_visibility;

	if (!$categories)
			$categories = $wpdb->get_results("SELECT term_id FROM $wpdb->terms");

	if ($categories) {
		foreach ($categories as $category) {
			$list = $category->term_id . "_list";

			if ($_POST["$list"] == "on") $list = 1; else $list = 0;

			if ( $list==1 ) {
				$wpdb->query("DELETE FROM $cat_visibility WHERE cat_ID=$category->term_id LIMIT 1");
			} else {
				$wpdb->query("REPLACE INTO $cat_visibility SET cat_ID=$category->term_id, list=$list");
			}
		}
	}
}

function cv_visible_cats($visibleto = 'front') {
   global $wpdb, $user_level, $cat_visibility;
    static $cv_cats = 0;
	if ($cv_cats == 0) {
		get_currentuserinfo();
		if (empty($user_level)) $user_level = 0;
		if (!is_numeric($user_level)) $user_level = 0;
		$my_query  = "SELECT * FROM $wpdb->terms";
		$my_query .= " LEFT JOIN $cat_visibility ON ($wpdb->terms.term_id = $cat_visibility.cat_ID)";
		$my_query .= " ORDER BY $wpdb->terms.name";
		$cv_cats = ($wpdb->get_results($my_query));
	}
	$callback = create_function('$obj', 'return (('
	. (  ($visibleto == 'none') ? '' : ('$obj->'.$visibleto.'==1 && '))
	. '$obj->cv_user_level<='.$user_level.') || $obj->cat_ID==0 );');
	return array_filter( $cv_cats,$callback );
}

function cv_alter_vis_catlist ($thelist) {
    global $wpdb;
    global $cat_visibility;

	$categories = cv_visible_cats('list');
    if (preg_match("/href/", $thelist)) {

        $newlist = "";
        $children = 0;
        $linklist = preg_split('/\t/', $thelist);
        foreach ($linklist as $link) {
            if(preg_match("/class.*categories/", $link)) {
                $children = 1;
                $newlist .= $link;
            } elseif(preg_match("/<\/ul>/", $link) && $children) {
                $children = 0;
                /* $newlist .= $link; */
                $thiscatname = strip_tags($link);
                $thiscatname = preg_replace("/\s+\(\d+\)\s+/", "", $thiscatname);
                $thiscatname = trim($thiscatname);
                if(!empty($thiscatname)) {
			$endlist = end($categories);
			foreach ($categories as $category) {
				if ($category->name == $thiscatname || wptexturize($category->name) == $thiscatname) {
					$newlist .= $link;
					break;
				} else if ($category->name == $endlist->name || wptexturize($category->name) == wptexturize($endlist->name)) {
					$newlist .= '</ul>';
					break;
				}
			}
		 } 
            } else {
                $thiscatname = strip_tags($link);
                $thiscatname = preg_replace("/\s+\(\d+\)\s+/", "", $thiscatname);
                $thiscatname = trim($thiscatname);
                if(!empty($thiscatname)) {
			foreach ($categories as $category) {
				if ($category->name == $thiscatname || wptexturize($category->name) == $thiscatname) {
				$newlist .= $link;
				break;
			}
		}
            }
        }
        }
        return $newlist;
    }
    $thiscatname = $thelist;
	foreach ($categories as $category) {
		if ($category->name == $thiscatname || wptexturize($category->name) == $thiscatname) {
			return $thelist;
		}
	}

	return;
}

function cv_get_posts($args) {
	global $wpdb;
	parse_str($args, $r);
	if ( !isset($r['numberposts']) )
		$r['numberposts'] = 5;
	if ( !isset($r['offset']) )
		$r['offset'] = 0;
	if ( !isset($r['orderby']) )
		$r['orderby'] = 'post_date';
	if ( !isset($r['order']) )
		$r['order'] = 'DESC';
	if ( !isset($r['visibleto']) )
		$r['visibleto'] = 'list';
	if ( !isset($r['category']) || $r['category']==FALSE) {
		$acats = cv_visible_cats($r['visibleto']); // cats visible, default list
		if (!empty($acats)) {
			$r['category'] = '';
			foreach ($acats as $category) {
				$r['category'] .= ((''!=$r['category']) ? ',':'') . $category->term_id;
			}
		}
	}
	$r['category'] = '('.$r['category'].')';
	$now = current_time('mysql');
	$posts = $wpdb->get_results(
		"SELECT * FROM $wpdb->posts " .
		( empty( $r['category'] ) ? "" : ", $wpdb->posts " ) .
		" WHERE post_date <= '$now' AND (post_status = 'publish') ".
		( empty( $r['category'] ) ? "" : "AND $wpdb->posts.ID = $wpdb->posts.ID AND $wpdb->terms.term_id in " . $r['category']. " " ) .
		" GROUP BY $wpdb->posts.ID ORDER BY " . $r['orderby'] . " " . $r['order'] . " LIMIT " . $r['offset'] . ',' . $r['numberposts'] );
	update_post_caches($posts);
	return $posts;
}

function cv_delete_cat($term_id) {
	global $wpdb;
	global $cat_visibility;
	$wpdb->query("DELETE FROM $cat_visibility WHERE cat_ID=$term_id LIMIT 1");
}

// Installs the tables needed for Category Visibility on Activation
// Check the codex article for more info
// http://codex.wordpress.org/creating_tables_with_plugins
function cv_install () {
   global $wpdb, $cat_visibility;

	// Check to see if table exists, check for old column name, change if necessary
    foreach ($wpdb->get_col("SHOW TABLES",0) as $table ) {
        if ($table == $cat_visibility) {
			// Found table
			foreach ($wpdb->get_col("DESC $cat_visibility", 0) as $column ) {
				if ($column == 'term_id') {
					// Found column, run query to change column name
						$wpdb->query("ALTER TABLE `$cat_visibility` CHANGE `term_id` `cat_ID` BIGINT( 20 ) NOT NULL DEFAULT '0', DROP INDEX `term_id`");
				} elseif ($column == 'user_level') {
					// Found column, run query to change column name
						$wpdb->query("ALTER TABLE `$cat_visibility` CHANGE `user_level` `cv_user_level` INT( 4 ) NOT NULL DEFAULT '0'");
				}
			}
            break;
        }
    }

   // PRIMARY KEY has 2 spaces on purpose ... some weird dbDelta thing...

   $qry = "CREATE TABLE ".$cat_visibility." (
			cat_ID bigint(20) NOT NULL,
			front int(4) NOT NULL default 1,
			list int(4) NOT NULL default 1,
			search int(4) NOT NULL default 1,
			feed int(4) NOT NULL default 1,
			archives int(4) NOT NULL default 1,
			cv_user_level int(4) NOT NULL default 0,
			PRIMARY KEY  (cat_ID)
           ); ";

    require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
    dbDelta($qry);

}

// Make sure WP is running
if (function_exists('add_action')) {

	add_action('admin_menu', 'cv_category_vis_menu');
	add_filter('wp_list_categories', 'cv_alter_vis_catlist');
	add_action('delete_category', 'cv_delete_cat');

	/* These actions are run through 'init' for security */

    // Run the install script when/if the plugin is activated manually or through RYO Quick Start
    if (isset($_GET['activate']) && $_GET['activate'] == 'true')
       add_action('init', 'cv_install');
}

class SimplyExclude
{
	var $se_cfg;
	var $options_key;
	var $default_IsActions;
	
	var $categories;
	var $pages;
	
	var $wp_version;
	
	function SimplyExclude()
	{
		global $wp_version;
		$this->wp_version = $wp_version;
		
		$this->_admin_menu_label	= "Simply Exclude";
		$this->options_key			= "simplyexclude";

		$this->se_load_config();

		add_action('admin_menu', array(&$this,'admin_init_proc'));

		// Add our own admin menu
		add_action('admin_menu', array(&$this,'se_add_nav'));

	  	if ($_REQUEST['page'] == $this->options_key)
			add_action('admin_head', array(&$this,'se_admin_head'));

		if (isset($_REQUEST['action']) && $_REQUEST['action'] == 'activate')
			add_action('init', array(&$this,'se_install'));
			
		// Used to limit the categories displayed on the home page. Simple
		add_filter('pre_get_posts', array(&$this,'se_filters'));
		
		add_action('save_post', array(&$this,'save_page_exclude_answer'));		
	}

	function admin_init_proc()
	{
		if (function_exists('add_meta_box')) {
			add_meta_box($this->_options_key, $this->_admin_menu_label, array(&$this,'add_page_exclude_sidebar_dbx'), 'page');
		}
		else { 
			add_filter('dbx_page_sidebar', array(&$this,'add_page_exclude_sidebar_dbx'));
		}
	}


	function se_load_config()
	{
		// This is the pre-defined WordPress is_* actions.
		$this->default_IsActions = array();

		// Define the actions allow on Post Categories
		$this->default_IsActions['cats'] = array();
		$this->default_IsActions['cats']['is_home']['name'] 		
			= "Front";
		$this->default_IsActions['cats']['is_home']['description']
			= "Visibility on the front/main page.";
		$this->default_IsActions['cats']['is_home']['action']
			= "i";
				
		$this->default_IsActions['cats']['is_archive']['name']			
			= "Archive";
		$this->default_IsActions['cats']['is_archive']['description']
			= "Visibility on the archive of categories on the sidebar";
		$this->default_IsActions['cats']['is_archive']['action']
			= "e";

		$this->default_IsActions['cats']['is_search']['name']
			= "Search";
		$this->default_IsActions['cats']['is_search']['description']
			= "Visibility in search results.";
		$this->default_IsActions['cats']['is_search']['action']
			= "e";

		$this->default_IsActions['cats']['is_feed']['name']
			= "Feed";
		$this->default_IsActions['cats']['is_feed']['description']
			= "Visibility in RSS/RSS2/Atom feeds.";
		$this->default_IsActions['cats']['is_feed']['action']
			= "e";

		$this->default_IsActions['cats']['is_archive']['name']
			= "Archive";			
		$this->default_IsActions['cats']['is_archive']['description']
			= "Visibility in archive links (i.e., calendar links).";
		$this->default_IsActions['cats']['is_archive']['action'] 	= "e";			

		
		// Tag Definitions
		$this->default_IsActions['tags'] = array();
		$this->default_IsActions['tags']['is_home']['name'] 		
			= "Front";
		$this->default_IsActions['tags']['is_home']['description']
			= "Visibility on the front/main page.";
		$this->default_IsActions['tags']['is_home']['action']
			= "i";
				
		$this->default_IsActions['tags']['is_archive']['name']			
			= "Archive";
		$this->default_IsActions['tags']['is_archive']['description']
			= "Visibility on the archive of tags on the sidebar";
		$this->default_IsActions['tags']['is_archive']['action']
			= "e";

		$this->default_IsActions['tags']['is_search']['name']
			= "Search";
		$this->default_IsActions['tags']['is_search']['description']
			= "Visibility in search results.";
		$this->default_IsActions['tags']['is_search']['action']
			= "e";

		$this->default_IsActions['tags']['is_feed']['name']
			= "Feed";
		$this->default_IsActions['tags']['is_feed']['description']
			= "Visibility in RSS/RSS2/Atom feeds.";
		$this->default_IsActions['tags']['is_feed']['action']
			= "e";

		$this->default_IsActions['tags']['is_archive']['name']
			= "Archive";			
		$this->default_IsActions['tags']['is_archive']['description']
			= "Visibility in archive links (i.e., calendar links).";
		$this->default_IsActions['tags']['is_archive']['action'] 	= "e";			


		// Pages Definitions
		$this->default_IsActions['pages'] = array();
		$this->default_IsActions['pages']['is_search']['name']			= "Search";
		$this->default_IsActions['pages']['is_search']['description']	= "Visibility in search results.";
		$this->default_IsActions['pages']['is_search']['action']		= "e";
			
		$this->se_cfg['cfg']['page_name']			= "simplyexclude";
		$tmp_se_cfg = get_option($this->options_key);
		if ($tmp_se_cfg)
		{
			if (!is_array($tmp_se_cfg))
				$this->se_cfg = unserialize($tmp_se_cfg);
		}	
		$plugindir_node 				= dirname(plugin_basename(__FILE__));	
		$plugindir_url 					= get_bloginfo('wpurl') . "/wp-content/plugins/". $plugindir_node;
		$this->se_cfg['cfg']['myurl'] 	= $plugindir_url;

		if (!isset($this->se_cfg['cats']['actions']))
		{
			foreach($this->default_IsActions['cats'] as $cat_key => $cat_action)
			{
				$this->se_cfg['cats']['actions'][$cat_key] = $cat_action['action'];
			}
		}
		if (!isset($this->se_cfg['tags']['actions']))
		{
			foreach($this->default_IsActions['tags'] as $tag_key => $tag_action)
			{
				$this->se_cfg['tags']['actions'][$tag_key] = $tag_action['action'];
			}
		}
		if (!isset($this->se_cfg['pages']['actions']))
		{
			foreach($this->default_IsActions['pages'] as $page_key => $page_action)
			{
				$this->se_cfg['pages']['actions'][$page_key] = $page_action['action'];
			}
		}
	}
	
	function se_save_config()
	{
		$ret = update_option($this->options_key, serialize($this->se_cfg));
	}
		
	
	function se_add_nav() 
	{
    	// Add a new menu under Manage:
    	add_options_page('Simply Exclude', 'Simply Exclude', 8, 
			$this->options_key, array(&$this, 'se_manage_page'));
	}

	function se_admin_head()
	{
		?>
		<link rel="stylesheet" href="<?php echo $this->se_cfg['cfg']['myurl'] ?>/simplyexclude_style_admin.css"
		 type="text/css" media="screen" />
		<?php 
	}

	function se_install()
	{
		add_option($this->options_key, 
				serialize($this->se_cfg), 
				"This is the serialized config structures used.");
	}

	function se_manage_page()
	{
		$this->se_display_navigation();

		?>
		<div class="wrap">
		<?php

			if (isset($_REQUEST['se_admin']))
				$se_admin = $_REQUEST['se_admin'];
	
			switch ($se_admin['action'])
			{
				case 'edit_pages':
				case 'save_pages':
					$this->se_display_pages_panel($se_admin);
					break;
	
				case 'edit_tags':
				case 'save_tags':
					$this->se_display_tags_panel($se_admin);
					break;


				default:
				case 'edit_categories':
				case 'save_categories':
					$this->se_display_categories_panel($se_admin);
					break;
			}
		?>
		</div>
		<?php
	}
	
	
	function se_display_navigation()
	{
		
		?>
		<div id="se_admin_nav">
			<ul>
				<li><a href="?page=<?php 
					echo $this->options_key ?>&amp;se_admin[action]=edit_categories"
					title="Manage Category Exclusions">Manage Categories</a></li>
				<?php
					if ($this->wp_version >= 2.3)
					{
						?>
						<li><a href="?page=<?php 
							echo $this->options_key ?>&amp;se_admin[action]=edit_tags"
							title="Manage Tag Exclusions">Manage Tags</a></li><?php
					}
				?>						
				<li><a href="?page=<?php 
					echo $this->options_key ?>&amp;se_admin[action]=edit_pages"
					title="Manage Page Exclusions">Manage Pages</a></li>
			</ul>
		</div>
		<?php
	}
		
	// CATEGORY FUNCTIONS
	/////////////////////////////////////////////////////////////////
	function se_display_categories_panel($se_admin)
	{
		?>
		<h2>Manage Category Exclusions</h2>
		<?php
		if ($se_admin['action'] == "save_categories")
		{
			if (isset($se_admin['cats']))
				$this->se_cfg['cats'] = $se_admin['cats'];
			else
				unset($this->se_cfg['cats']);
			
			$this->se_save_config();				
			?>
			<div class="updated">
				<p>Category Exclusions successfully updated.</p>
			</div>
			<?php
		}
		$this->se_show_categories_form();
	}

	function se_load_categories()
	{
		global $wpdb;
		if (!$this->categories)
		{
			//$this->categories = $wpdb->get_results("SELECT cat_ID, cat_name 
			//						FROM $wpdb->categories ORDER BY cat_name");
										
			$this->categories = get_categories();			
		}
	}
	
	function se_show_categories_form()
	{
		$this->se_load_categories();
		if ($this->categories)
		{
			$this->display_instructions('cats');
			?>
			<form name="cat_exclusion" id="cat_exclusion" 
				action="?page=<?php 
					echo $this->options_key ?>&amp;se_admin[action]=save_categories" method="post">

				<table  width="80%" cellpadding="3" cellspacing="3" border="0">
				<thead>
		        <tr>
		        	<th><?php _e('Action Name') ?></th>
		        	<th><?php _e('Description ') ?></th>
		        	<th><?php _e('Inclusion/Exclusion') ?></th>
		        </tr>
				</thead>
				<tbody>
				<?php
				foreach ($this->default_IsActions['cats'] as $action_key => $action_val)
				{
					$class = ('alternate' == $class) ? '' : 'alternate';
					?>
					<tr <?php if (strlen($class)) echo "class='".$class."'" ?>>
						<td><?php echo $action_val['name'] ?></td>
						<td><?php echo $action_val['description'] ?></td>
						<td>
							<input type="radio" 
								name="se_admin[cats][actions][<?php echo $action_key ?>]" value="i" 
								<?php if ($this->se_cfg['cats']['actions'][$action_key] == 'i') 
									echo "checked='checked'"; ?> /> Include only<br />
							<input type="radio" 
								name="se_admin[cats][actions][<?php echo $action_key ?>]" value="e" 
								<?php if ($this->se_cfg['cats']['actions'][$action_key] == 'e') 
									echo "checked='checked'"; ?> /> Exclude
						</td>
					<tr>
					<?php
				}
				?>
				</tbody>
				</table>
				<br />
				<table  width="80%" cellpadding="3" cellspacing="3" border="0">
				<thead>
		        <tr>
		        	<th class="cat-id" scope="col"><?php _e('ID') ?></th>
		        	<th class="cat-name" scope="col"><?php _e('Category Name') ?></th>
		        	<th class="cat-action" scope="col"><?php _e('Exclude from...') ?></th>
		        </tr>
				</thead>
				<tbody>
				<?php
					foreach($this->categories as $cat_info)
					{	
						$class = ('alternate' == $class) ? '' : 'alternate';
						$this->se_show_cat_item_row($cat_info, $class);
					}
				?>		
				<tr>
					<td>
						<div style="float:right;"><p class="submit"><input type="hidden" name="action" value="editcatvis" /><input type="submit" name="submit" value="<?php _e('Save Changes &raquo;') ?>" />
						
					</td>
				</tr>
				</tbody>
				</table>
				</p></div>				
			</form>
			<?php
		}
	}
	
	function se_show_cat_item_row($cat_info, $class)
	{
		?>
		<tr <?php if (strlen($class)) echo "class='".$class."'" ?>>
			<td class="cat-id"><?php echo $cat_info->cat_ID ?></td>
			<td class="cat-name"><?php echo $cat_info->cat_name ?></td>
			<td class="cat-action"><?php $this->se_display_cat_action_row($cat_info->cat_ID) ?></td>
		</tr>
		<?php
	}
	
	function se_display_cat_action_row($cat_id)
	{
		foreach ($this->default_IsActions['cats'] as $action_key => $action_val)
		{
			?>
			<label for="cats-<?php echo $action_key ?>-<?php echo $cat_id ?>">
				<?php echo $action_val['name'] ?></label>&nbsp;
			<input type="checkbox" 
				name="se_admin[cats][<?php echo $action_key ?>][<?php echo $cat_id ?>]"
				id="cats-<?php echo $action_key ?>-<?php echo $cat_id ?>"
				<?php
				if ($this->se_cfg['cats'][$action_key][$cat_id] == "on")
					echo "checked='checked' ";
				?> />
			<?php
		}
	}
	
	// END CONFIG FUNCTIONS
	/////////////////////////////////////////////////////////////////


	// TAG FUNCTIONS
	/////////////////////////////////////////////////////////////////
	function se_display_tags_panel($se_admin)
	{
		?>
		<h2>Manage Tag Exclusions</h2>
		<?php
		if ($se_admin['action'] == "save_tags")
		{
			if (isset($se_admin['tags']))
				$this->se_cfg['tags'] = $se_admin['tags'];
			else
				unset($this->se_cfg['tags']);
			
			$this->se_save_config();				
			?>
			<div class="updated">
				<p>Tag Exclusions successfully updated.</p>
			</div>
			<?php
		}
		$this->se_show_tags_form();
	}
	
	function se_load_tags()
	{
		global $wpdb;
		if (!$this->tags)
		{
			$this->tags = get_tags();			
		}
	}
	
	
	function se_show_tags_form()
	{
		$this->se_load_tags();
		if ($this->tags)
		{
			$this->display_instructions('tags');
			?>
			<form name="tag_exclusion" id="tag_exclusion" 
				action="?page=<?php 
					echo $this->options_key ?>&amp;se_admin[action]=save_tags" method="post">

				<table  width="80%" cellpadding="3" cellspacing="3" border="0">
				<thead>
		        <tr>
		        	<th><?php _e('Action Name') ?></th>
		        	<th><?php _e('Description ') ?></th>
		        	<th><?php _e('Inclusion/Exclusion') ?></th>
		        </tr>
				</thead>
				<tbody>
				<?php
				foreach ($this->default_IsActions['tags'] as $action_key => $action_val)
				{
					$class = ('alternate' == $class) ? '' : 'alternate';
					?>
					<tr <?php if (strlen($class)) echo "class='".$class."'" ?>>
						<td><?php echo $action_val['name'] ?></td>
						<td><?php echo $action_val['description'] ?></td>
						<td>
							<input type="radio" 
								name="se_admin[tags][actions][<?php echo $action_key ?>]" value="i" 
								<?php if ($this->se_cfg['tags']['actions'][$action_key] == 'i') 
									echo "checked='checked'"; ?> /> Include only<br />
							<input type="radio" 
								name="se_admin[tags][actions][<?php echo $action_key ?>]" value="e" 
								<?php if ($this->se_cfg['tags']['actions'][$action_key] == 'e') 
									echo "checked='checked'"; ?> /> Exclude
						</td>
					<tr>
					<?php
				}
				?>
				</tbody>
				</table>
				<br />
				<table  width="80%" cellpadding="3" cellspacing="3" border="0">
				<thead>
		        <tr>
		        	<th class="cat-id" scope="col"><?php _e('ID') ?></th>
		        	<th class="cat-name" scope="col"><?php _e('Tag Name') ?></th>
		        	<th class="cat-action" scope="col"><?php _e('Exclude from...') ?></th>
		        </tr>
				</thead>
				<tbody>
				<?php
					foreach($this->tags as $tag_info)
					{	
						$class = ('alternate' == $class) ? '' : 'alternate';
						$this->se_show_tag_item_row($tag_info, $class);
					}
				?>		
				<tr>
					<td>
						<div style="float:right;"><p class="submit"><input type="hidden" name="action" value="editcatvis" /><input type="submit" name="submit" value="<?php _e('Save Changes &raquo;') ?>" />
						
					</td>
				</tr>
				</tbody>
				</table>
				</p></div>				
			</form>
			<?php
		}
	}
	
	
	function se_show_tag_item_row($tag_info, $class)
	{
		?>
		<tr <?php if (strlen($class)) echo "class='".$class."'" ?>>
			<td class="tag-id"><?php echo $tag_info->term_id ?></td>
			<td class="tag-name"><?php echo $tag_info->name ?></td>
			<td class="tag-action"><?php $this->se_display_tag_action_row($tag_info->term_id) ?></td>
		</tr>
		<?php
	}
	
	function se_display_tag_action_row($tag_id)
	{
		foreach ($this->default_IsActions['tags'] as $action_key => $action_val)
		{
			?>
			<label for="tags-<?php echo $action_key ?>-<?php echo $tag_id ?>">
				<?php echo $action_val['name'] ?></label>&nbsp;
			<input type="checkbox" 
				name="se_admin[tags][<?php echo $action_key ?>][<?php echo $tag_id ?>]"
				id="tags-<?php echo $action_key ?>-<?php echo $tag_id ?>"
				<?php
				if ($this->se_cfg['tags'][$action_key][$tag_id] == "on")
					echo "checked='checked' ";
				?> />
			<?php
		}
	}
	

	// END CONFIG FUNCTIONS
	/////////////////////////////////////////////////////////////////


	// PAGE FUNCTIONS
	/////////////////////////////////////////////////////////////////
	function se_display_pages_panel($se_admin)
	{
		?>
		<h2>Manage Page Exclusions</h2>
		<?php
		if ($se_admin['action'] == "save_pages")
		{
			if (isset($se_admin['pages']))
			{
				$this->se_cfg['pages'] = $se_admin['pages'];
				$this->se_save_config();
				?>
				<div class="updated">
					<p>Page Exclusions successfully updated.</p>
				</div>
				<?php
			}
		}
		$this->se_show_pages_form();
	}

	function se_load_pages()
	{
		global $wpdb;
		if (!$this->pages)
			$this->pages = $wpdb->get_results("SELECT ID, post_title 
							FROM $wpdb->posts 
							WHERE post_type='page'
							AND post_status='publish'
							ORDER BY post_title");
	}

	function se_show_pages_form()
	{
		//$this->display_instructions('pages');
		//return;

		$this->se_load_pages();
		if ($this->pages)
		{
			$this->display_instructions('pages');
			?>			
			<form name="page_exclusion" id="page_exclusion" 
				action="?page=<?php 
					echo $this->options_key ?>&amp;se_admin[action]=save_pages" method="post">
				<table  width="80%" cellpadding="3" cellspacing="3" border="0">
				<thead>
		        <tr>
		        	<th><?php _e('Action Name') ?></th>
		        	<th><?php _e('Description ') ?></th>
		        	<th><?php _e('Inclusion/Exclusion Default') ?></th>
		        </tr>
				</thead>
				<tbody>
				<?php
				foreach ($this->default_IsActions['pages'] as $action_key => $action_val)
				{
					$class = ('alternate' == $class) ? '' : 'alternate';
					?>
					<tr <?php if (strlen($class)) echo "class='".$class."'" ?>>
						<td><?php echo $action_val['name'] ?></td>
						<td><?php echo $action_val['description'] ?></td>
						<td>
							<input type="radio" 
								name="se_admin[pages][actions][<?php echo $action_key ?>]" value="i" 
								<?php if ($this->se_cfg['pages']['actions'][$action_key] == 'i') 
									echo "checked='checked'"; ?> /> Include only<br />
							
							<input type="radio" 
								name="se_admin[pages][actions][<?php echo $action_key ?>]" value="e" 
								<?php if ($this->se_cfg['pages']['actions'][$action_key] == 'e') 
									echo "checked='checked'"; ?> /> Exclude
						</td>
					<tr>
					<?php
				}
				?>
				</tbody>
				</table>
				<br />


				<table width="80%" cellpadding="3" cellspacing="3">
				<thead>
		        <tr>
		        	<th class="page-id" scope="col"><?php _e('ID') ?></th>
		        	<th class="page-name" scope="col"><?php _e('Title') ?></th>
		        	<th class="page-action" scope="col"><?php _e('Exclude from...') ?></th>
		        </tr>
				</thead>
				<tbody>
				<?php
					foreach($this->pages as $page_info)
					{
						$class = ('alternate' == $class) ? '' : 'alternate';						
						$this->se_show_page_item_row($page_info, $class);
					}
				?>	
				<tr>
					<td>
						<div style="float:right;"><p class="submit"><input type="hidden" name="action" value="editcatvis" /><input type="submit" name="submit" value="<?php _e('Save Changes &raquo;') ?>" />
						</p></div>
						
					</td>
				</tr>
				</tbody>	
				</table>
				
			</form>
			<?php
		}
	}

	function se_show_page_item_row($page_info, $class = '')
	{
		?>
		<tr <?php if (strlen($class)) echo "class='".$class."'" ?>>
			<td class="page-id"><?php echo $page_info->ID ?></td>
			<td class="page-name"><?php echo $page_info->post_title ?></td>
			<td class="page-action"><?php $this->se_display_page_action_row($page_info->ID) ?></td>
		</tr>
		<?php
	}
	
	
	function se_display_page_action_row($page_id)
	{
		foreach ($this->default_IsActions['pages'] as $action_key => $action_val)
		{
			?>
			<label for="pages-<?php echo $action_key ?>-<?php echo $page_id ?>">
				<?php echo $action_val['name'] ?></label>&nbsp;
			<input type="checkbox" 
				name="se_admin[pages][<?php echo $action_key ?>][<?php echo $page_id ?>]"
				id="pages-<?php echo $action_key ?>-<?php echo $page_id ?>"
				<?php
					
				if ($this->se_cfg['pages'][$action_key][$page_id] == "on")
					echo "checked='checked' ";
				?> />
			<?php
		}
	}
	
	function get_pages_list($sep, $ids)
	{		
		foreach($ids as $id_key => $id_val)
		{
			if (strlen($id_list))
				$id_list .= ",";
			$id_list .= $id_key;
		}
		return $id_list;
		
	}
	
	// The following 2 function we taken from the wonderful SearchEverything plugin. 
	// http://wordpress.org/extend/plugins/search-everything/
	function SE4_exclude_posts($where) {
		global $wp_query;
		if (!empty($wp_query->query_vars['s'])) 
		{
			$action_key = "is_search";
			$excl_list = $this->get_pages_list(',', $this->se_cfg['pages'][$action_key]);

			//$excl_list = implode(',', explode(',', trim($this->options['SE4_exclude_posts_list'])));
			
			$where = str_replace('"', '\'', $where);
			$where = 'AND ('.substr($where, strpos($where, 'AND')+3).' )';
			if ($this->se_cfg['pages']['actions'][$action_key] == 'e')
				$where .= ' AND (ID NOT IN ( '.$excl_list.' ))';
			else
				$where .= ' AND (ID IN ( '.$excl_list.' ))';			
		}
		return $where;
	}

	//search pages (except password protected pages provided by loops)
	function SE4_search_pages($where) {
		global $wp_query;

		if (!empty($wp_query->query_vars['s'])) {

			$where = str_replace('"', '\'', $where);
			if ('true' == $this->options['SE4_approved_pages_only']) {
				$where = str_replace('post_type = \'post\' AND ', 'post_password = \'\' AND ', $where);
			}
			else { // < v 2.1
				$where = str_replace('post_type = \'post\' AND ', '', $where);
			}
		}
		return $where;
	}
	
	

	// END CONFIG FUNCTIONS
	/////////////////////////////////////////////////////////////////
	
	
	function se_filters($query) 
	{
		//echo "query before<pre>"; print_r($query); echo "</pre>";
		
		foreach ($this->default_IsActions['cats'] as $action_key => $action_val)
		{
			if ($query->{$action_key})
			{
				if (isset($this->se_cfg['cats'][$action_key]))
				{
					$cats_list = $this->se_listify_ids( $this->se_cfg['cats']['actions'][$action_key],
														$this->se_cfg['cats'][$action_key]);
				}
				if (strlen($cats_list))
					$query->set('cat', $cats_list);
			}
		}
		if ($this->wp_version >= 2.3)
		{
			foreach ($this->default_IsActions['tags'] as $action_key => $action_val)
			{
				if ($query->{$action_key})
				{
					if (isset($this->se_cfg['tags'][$action_key]))
					{
						$array_list = array();
						foreach($this->se_cfg['tags'][$action_key] as $key => $val)
						{
							$array_list[] = $key; 
						}

						if ($this->se_cfg['tags']['actions'][$action_key] == "e")
						{
							$query->set('tag__not_in', $array_list);
						}
						else
						{
							$query->set('tag__in', $array_list);
						}

					}
				}
			}
		}
		
		foreach ($this->default_IsActions['pages'] as $action_key => $action_val)
		{
			//echo "action_key=[". $action_key. "]<br />";
			if ($query->{$action_key})
			{
				add_filter('posts_where', array(&$this, 'SE4_search_pages'));
				add_filter('posts_where', array(&$this, 'SE4_exclude_posts'));

/*
				$pages_list;
				if (isset($this->se_cfg['pages'][$action_key]))
				{
					//echo "this->se_cfg['pages'][$action_key]=[". $this->se_cfg['pages'][$action_key]. "]<br />";
					
					$pages_list = $this->se_listify_ids($this->se_cfg['pages']['actions'][$action_key], 
														$this->se_cfg['pages'][$action_key]);
					//echo "pages_list=[". $pages_list."]<br />";
				}
				if (strlen($pages_list))
					$query->set('page', $pages_list);
*/
			}
		}
		//echo "query after<pre>"; print_r($query); echo "</pre>";
		return $query;
	}

	function se_listify_ids($action, $ids)
	{
		if ($action == "e")
			$action_value = "-";
		else
			$action_value = "";
		foreach($ids as $id_key => $id_val)
		{
			if (strlen($id_list))
				$id_list .= ",";
			$id_list .= $action_value.$id_key;
		}
		return $id_list;
	}


	function display_instructions($type)
	{
		if ($type == "cats")
		{
			?>
			<p>Set the checkbox to exclude the respective page from the action</p>
			<p>So what is the difference between Exclusion and Inclusion?<br />
				<strong>Exclude</strong>: Select this action to exclude Categories from WP 
					action. For example you may wish to exclude the Category 'Blogroll' from Searches.<br />
				<strong>Include</strong>: Select the Categories you wish to be included for certain 
					WP actions. For example you want only a certain category displayed on the home 
					page. Note that with Include only those checked items will be included in the 
					WP action. </p>
			<?php
		}
		else if ($type == "tags")
		{
			?>
			<p>Set the checkbox to exclude the respective page from the action</p>
			<p>So what is the difference between Exclusion and Inclusion?<br />
				<strong>Exclude</strong>: Select this action to exclude Tags from WP 
					action. For example you may wish to exclude the Tag 'Blogroll' from Searches.<br />
				<strong>Include</strong>: Select the Tag you wish to be included for certain 
					WP actions. For example you want only a certain tag displayed on the home 
					page. Note that with Include only those checked items will be included in the 
					WP action. </p>
			<?php
		}
		else if ($type == "pages")
		{
		
			?>
			<p>Set the checkbox to exclude the respective page from the action</p>
			<p>So what is the difference between Exclusion and Inclusion?<br />
				<strong>Exclude</strong>: Select this action to exclude Pages from WP 
					action. For example you may wish to exclude a Page from Searches. Most common use.<br />
				<strong>Include</strong>: Select the Page you wish to be included for certain 
					WP actions. For example you want only certain Pages displayed from a Search. Note with Include only those checked items will be included in the 
					WP action. And as new Pages are added they will need to be checked here. </p>

			<p><strong>Note</strong>: The Pages section of this plugin is at best experimental until Page Search is included 
				by default into WordPress core. Also, you might consider using the SearchEverything plugin which offers much more
				 functionality on Searched. http://wordpress.org/extend/plugins/search-everything/</p>
			<?php
		
		/*
		?>
		<p>This is a placeholder section for Pages Exclusion. Since WordPress does not yet include Pages in searches this section is pointless. From various sources version 2.6 of WordPress should include native support for including Pages in search results. Look for changes to this plugin shortly after that.</p>
		<?php	
		*/
		}
	}
	
	function add_page_exclude_sidebar_dbx()
	{
		global $post;
		
		$action_key = "is_search";
		
		if ($this->se_cfg['pages'][$action_key][$post->ID] == "on")
			$exclude_page = "yes";

		if ($this->wp_version < 2.5)
		{
			?>
			<fieldset id="use_ssl" class="dbx-box">
				<h3 class="dbx-handle"><?php _e('Exclude from Search?') ?></h3> 
				<div class="dbx-content">
			<?php
		}
		?>
				<p><?php
				if ($this->wp_version >= 2.5)
				{
					?>Select this option 'Yes' to exclude this page from Searches or visit <a href="<?php echo get_option('siteurl') ?>/wp-admin/edit.php?page=simplyexclude&amp;se_admin[action]=edit_pages">Simply Exclude</a> Settings page to mass edit all Pages.<br /><?php
				} ?>
					<select name="se_page_exclude">
						<option value='No' selected><?php echo _e('No'); ?></option>
						<option value='Yes' <?php if ($exclude_page == "yes") echo "selected"; ?>><?php _e('Yes'); ?></option>
					</select>
				</p>
		<?php 
		if ($this->wp_version < 2.5)
		{
			?>
				</div>
			</fieldset>
			<?php
		}
	}
	

	function save_page_exclude_answer()
	{
		if (!$_REQUEST['post_ID'])
			return;
		
		if (!$_REQUEST['se_page_exclude'])
			return;
		
		$post_id = 	$_REQUEST['post_ID'];
		$action_key = "is_search";
		
		if ($_REQUEST['se_page_exclude'] == "Yes")
			$this->se_cfg['pages'][$action_key][$post_id] = "on";
		else
			$this->se_cfg['pages'][$action_key][$post_id] = "";

		$this->se_save_config();				
	}
}
$simplyexclude = new SimplyExclude();

/*
function myBlogPostsFilter($query) 
{
	global $wp_query;
	
	if ($query->is_search)
	{
		$query->set('cat','-3,-4,-5,-6,-7');
		$query->set('page','-33');
	}
	return $query;
}
add_filter('pre_get_posts','myBlogPostsFilter');
*/
?>